libqalculate-4.9.0: Unit Class Reference

libqalculate-4.9.0

Public Member Functions | Protected Attributes | List of all members
Unit Class Reference

A unit for measurement. More...

`#include <Unit.h>`

Inheritance diagram for Unit:

## Public Member Functions
| Unit (std::string cat_, std::string name_, std::string plural_="", std::string singular_="", std::string title_="", bool is_local=true, bool is_builtin=false, bool is_active=true)
| Unit (const Unit *unit)
virtual ExpressionItem * | copy () const
virtual void | set (const ExpressionItem *item)
bool | isSIUnit () const
void | setAsSIUnit ()
void | setSystem (std::string s_system)
const std::string & | system () const
bool | useWithPrefixesByDefault () const
int | maxPreferredPrefix () const
int | minPreferredPrefix () const
int | defaultPrefix () const
void | setUseWithPrefixesByDefault (bool use_with_prefixes)
void | setMaxPreferredPrefix (int exp)
void | setMinPreferredPrefix (int exp)
void | setDefaultPrefix (int exp)
bool | isCurrency () const
const std::string & | countries () const
void | setCountries (std::string country_names)
virtual std::string | print (bool plural_, bool short_, bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual std::string | print (const PrintOptions &po, bool format=false, int tagtype=0, bool input=false, bool plural=true) const
virtual const std::string & | plural (bool return_singular_if_no_plural=true, bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const std::string & | singular (bool return_abbreviation_if_no_singular=true, bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const std::string & | abbreviation (bool return_singular_if_no_abbreviation=true, bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual bool | isUsedByOtherUnits () const
virtual Unit * | baseUnit () const
virtual MathStructure & | convertToBaseUnit (MathStructure &mvalue, MathStructure &mexp) const
virtual MathStructure & | convertFromBaseUnit (MathStructure &mvalue, MathStructure &mexp) const
virtual MathStructure & | convertToBaseUnit (MathStructure &mvalue) const
virtual MathStructure & | convertFromBaseUnit (MathStructure &mvalue) const
virtual MathStructure | convertToBaseUnit () const
virtual MathStructure | convertFromBaseUnit () const
virtual int | baseExponent (int exp=1) const
virtual int | type () const
virtual int | subtype () const
virtual bool | isChildOf (Unit *u) const
virtual bool | isParentOf (Unit *u) const
virtual bool | hasNonlinearRelationTo (Unit *u) const
virtual bool | hasApproximateRelationTo (Unit *u, bool check_variables=false, bool ignore_high_precision_intervals=false) const
virtual bool | containsRelativeTo (Unit *u) const
virtual bool | hasNonlinearRelationToBase () const
virtual bool | hasApproximateRelationToBase (bool check_variables=false, bool ignore_high_precision_intervals=false) const
bool | convert (Unit *u, MathStructure &mvalue, MathStructure &exp) const
bool | convert (Unit *u, MathStructure &mvalue) const
MathStructure | convert (Unit *u, bool *converted=NULL) const
Public Member Functions inherited from ExpressionItem
| ExpressionItem (std::string cat_, std::string name_, std::string title_="", std::string descr_="", bool is_local=true, bool is_builtin=false, bool is_active=true)
virtual bool | destroy ()
bool | isRegistered () const
void | setRegistered (bool is_registered)
| For internal use.
virtual const std::string & | name (bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const std::string & | referenceName () const
virtual const ExpressionName & | preferredName (bool abbreviation=false, bool use_unicode=false, bool plural=false, bool reference=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const ExpressionName & | preferredInputName (bool abbreviation=false, bool use_unicode=false, bool plural=false, bool reference=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const ExpressionName & | preferredDisplayName (bool abbreviation=false, bool use_unicode=false, bool plural=false, bool reference=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const ExpressionName & | getName (size_t index) const
virtual void | setName (const ExpressionName &ename, size_t index=1, bool force=true)
virtual void | setName (std::string sname, size_t index, bool force=true)
virtual void | addName (const ExpressionName &ename, size_t index=0, bool force=true)
virtual void | addName (std::string sname, size_t index=0, bool force=true)
virtual size_t | countNames () const
virtual void | clearNames ()
virtual void | clearNonReferenceNames ()
virtual void | removeName (size_t index)
virtual size_t | hasName (const std::string &sname, bool case_sensitive=true) const
virtual size_t | hasNameCaseSensitive (const std::string &sname) const
virtual const ExpressionName & | findName (int abbreviation=-1, int use_unicode=-1, int plural=-1, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const std::string & | title (bool return_name_if_no_title=true, bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual void | setTitle (std::string title_)
virtual const std::string & | description () const
virtual void | setDescription (std::string descr_)
virtual const std::string & | category () const
virtual void | setCategory (std::string cat_)
virtual bool | hasChanged () const
virtual void | setChanged (bool has_changed)
virtual bool | isLocal () const
virtual bool | setLocal (bool is_local=true, int will_be_active=-1)
virtual bool | isBuiltin () const
virtual bool | isApproximate () const
virtual void | setApproximate (bool is_approx=true)
virtual int | precision () const
virtual void | setPrecision (int prec)
virtual bool | isActive () const
virtual void | setActive (bool is_active)
virtual bool | isHidden () const
virtual void | setHidden (bool is_hidden)
virtual int | refcount () const
virtual void | ref ()
virtual void | unref ()
virtual void | ref (ExpressionItem *o)
virtual void | unref (ExpressionItem *o)
virtual ExpressionItem * | getReferencer (size_t index=1) const
virtual bool | changeReference (ExpressionItem *o_from, ExpressionItem *o_to)
virtual int | id () const

## Protected Attributes
std::string | ssystem
std::string | scountries
bool | b_si
unsigned short | b_use_with_prefixes
Protected Attributes inherited from ExpressionItem
std::string | scat
std::string | stitle
std::string | sdescr
bool | b_local
bool | b_changed
bool | b_builtin
bool | b_approx
bool | b_active
bool | b_registered
bool | b_hidden
bool | b_destroyed
int | i_ref
int | i_precision
std::vector< ExpressionItem * > | v_refs
std::vector< ExpressionName > | names

## Detailed Description

A unit for measurement.

The Unit class both represents a base unit and is the base class for other unit types. Base units are units defined as basis for other units. Meters and seconds are typical base units.

For base units, a name is all that is needed. Base units do however normally have three different names defined for use in expressions - abbreviation (ex. "m"), singular ("meter") and plural ("meters").

## Member Function Documentation

## ◆ containsRelativeTo()

virtual bool Unit::containsRelativeTo | ( | Unit * | u | ) | const
| virtual

Reimplemented in CompositeUnit.

## ◆ convert() [1/2]

bool Unit::convert | ( | Unit * | u,
|  | MathStructure & | mvalue
| ) |  | const

Converts a value from specified unit and exponent to this unit. value * unit = new value * this This function cannot convert to or from CompositeUnit.

Parameters

  | u | Unit to convert from.
  [in,out] | mvalue | Quantity value.

Returns
  true if the value was successfully converted.

## ◆ convert() [2/2]

bool Unit::convert | ( | Unit * | u,
|  | MathStructure & | mvalue,
|  | MathStructure & | exp
| ) |  | const

Converts a value from specified unit and exponent to this unit. value * (unit^exponent) = new value * (this^new exponent) This function cannot convert to or from CompositeUnit.

Parameters

  | u | Unit to convert from.
  [in,out] | mvalue | Quantity value.
  [in,out] | exp | Exponent.

Returns
  true if the value was successfully converted.

## ◆ copy()

virtual ExpressionItem * Unit::copy | ( |  | ) | const
| virtual

Implements ExpressionItem.

## ◆ isChildOf()

virtual bool Unit::isChildOf | ( | Unit * | u | ) | const
| virtual

If specified unit is a base unit for this unit, directly or with other units in between. Equivalent to u->isParentOf(this).

Reimplemented in AliasUnit.

## ◆ isCurrency()

bool Unit::isCurrency | ( |  | ) | const

Returns if the unit is a currency (Euro is base unit).

Returns
  true if the unit is a currency.

## ◆ isParentOf()

virtual bool Unit::isParentOf | ( | Unit * | u | ) | const
| virtual

If this unit is a base unit for specified unit, directly or with other units in between. Equivalent to u->isChildOf(this).

Reimplemented in AliasUnit.

## ◆ isSIUnit()

bool Unit::isSIUnit | ( |  | ) | const

Returns if the unit is part of the SI standard.

Returns
  true if the unit is part of the SI standard.

## ◆ print()

virtual std::string Unit::print | ( | bool | plural_,
|  | bool | short_,
|  | bool | use_unicode = `false`,
|  | bool(*)(const char *, void *) | can_display_unicode_string_function = `NULL`,
|  | void * | can_display_unicode_string_arg = `NULL`
| ) |  | const
| virtual

Returns a display string representing the unit in an expression.

Equivalent to preferredName() for Unit and AliasUnit, but closer to MathStructure::print() for CompositeUnit (prints out base expression).

Reimplemented in AliasUnit_Composite, and CompositeUnit.

## ◆ set()

virtual void Unit::set | ( | const ExpressionItem * | item | ) |
| virtual

Reimplemented from ExpressionItem.

## ◆ setAsSIUnit()

void Unit::setAsSIUnit | ( |  | ) |

State that the unit is part of the SI standard. Sets system to "SI".

## ◆ setSystem()

void Unit::setSystem | ( | std::string | s_system | ) |

Sets which system/standard ("SI", "CGS", etc.) the unit is part of. Setting system to "SI" (case-insensitive), is equivalent to setAsSIUnit().

## ◆ setUseWithPrefixesByDefault()

void Unit::setUseWithPrefixesByDefault | ( | bool | use_with_prefixes | ) |

Sets whether prefixes are appropriate with this unit or not.

## ◆ subtype()

virtual int Unit::subtype | ( |  | ) | const
| virtual

Returns the subtype of the unit, corresponding to which subsubclass the object belongs to.

Returns
  UnitSubtype.

Implements ExpressionItem.

Reimplemented in AliasUnit, and CompositeUnit.

## ◆ system()

const std::string & Unit::system | ( |  | ) | const

Returns the system/standard that the unit is part of.

Returns
  System string.

## ◆ type()

virtual int Unit::type | ( |  | ) | const
| virtual

Returns the type of the expression item, corresponding to which subclass the object belongs to.

Returns
  ExpressionItemType.

Implements ExpressionItem.

## ◆ useWithPrefixesByDefault()

bool Unit::useWithPrefixesByDefault | ( |  | ) | const

Returns whether prefixes should be used with this unit or not.

Returns
  true if the prefixes is appropriate for this unit.

The documentation for this class was generated from the following file:

- /build/libqalculate/src/libqalculate-4.9.0/libqalculate/Unit.h